#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\printer.h>
#include <owl\dc.h>
#include <owl\editfile.rh>
#include "pr32_1.rc"

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw : public TFrameWindow
{
  public:
        TWndw(TWindow *parent, const char far *title);
        ~TWndw();
  protected:
        TPrinter *printer;
        void Paint(TDC &dc, BOOL, TRect&);
        void CmFilePrint();

        DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
      EV_COMMAND(CM_FILEPRINT, CmFilePrint), 
END_RESPONSE_TABLE;

//  .
class TWndwPrintout : public TPrintout
{
  protected:
       TWindow *window;
  public:
       TWndwPrintout (const char *title, TWindow *w);
       void PrintPage (int, TRect &rect, unsigned);
};

TWndw::TWndw(TWindow *parent, const char far *title):
		  TFrameWindow(parent,title, 0, FALSE)
{
	//     .
	AssignMenu("MENU_1");
	//     .
	Attr.X=50;
	Attr.Y=50;
	Attr.W=400;
	Attr.H=200;
        //    TPrinter. 
        printer = new TPrinter;
}

// TWndw::~TWndw()
//    .
TWndw::~TWndw() 
{
    delete printer;
}

//TWndw::CmFilePrint()
//      Print  File.
void  TWndw::CmFilePrint()
{
  //    ...
  if (printer)
  {
     //    . 
     TWndwPrintout printout(" ", this);
     //   . 
     printer->Print(this, printout, TRUE);
  }
}

//TWndw::Paint()
//     Paint() 
// TWindow     WM_PAINT, 
// Windows  ,    
// . ,    
//   TPrinter  
//  ,    
//     .
void TWndw::Paint(TDC &dc, BOOL, TRect&)
{
  //  .
  dc.Rectangle (10,10,100,100);
}

//TWndwPrintout::TWndwPrintout()
//     .
TWndwPrintout::TWndwPrintout(const char *title, TWindow *w) :
     TPrintout(title) 
{
  //      .
  window = w;
}

// TWndwPrintout::PrintPage()
//      
// .     
//  ,    .
void TWndwPrintout::PrintPage (int, TRect &rect, unsigned) 
{
  TSize oldVpExt, oldWndExt;
  //    .
  int prevMode = DC->SetMapMode(MM_ISOTROPIC) ;
  //     .
  TRect wndSize = window->GetClientRect();
  //  window    
  //   .
  DC->SetWindowExt(wndSize.Size(),&oldWndExt);
  //     
  //   .
  DC->SetViewportExt(PageSize, &oldVpExt);
  //     Paint(),
  //     TPrinter,
  //     .
  window->Paint(*DC, FALSE, rect);
  //      .
  DC->SetWindowExt(oldWndExt);
  DC->SetViewportExt(oldVpExt);
  DC->SetMapMode(prevMode);
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw= new TWndw(0,"  2");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
